(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.GCLParser = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

module.exports = require('./lib/parser');

},{"./lib/parser":3}],2:[function(require,module,exports){
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dict;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Sym = require('./sym');
var types = require('./types');

var INTEGER = types.INTEGER;
var NUMBER = types.NUMBER;
var DECIMAL = types.DECIMAL;
var STRING = types.STRING;
var LITERAL = types.LITERAL;
var HEX = types.HEX;

var MS = types.MS;
var MB = types.MB;
var KB = types.KB;
var ARROW = types.ARROW;
var SCAVENGE = types.SCAVENGE;
var MARK_SWEEP = types.MARK_SWEEP;
var MEMORY_ALLOCATOR = types.MEMORY_ALLOCATOR;
var OLD_SPACE = types.OLD_SPACE;
var NEW_SPACE = types.NEW_SPACE;
var OLD_POINTERS = types.OLD_POINTERS;
var OLD_DATA_SPACE = types.OLD_DATA_SPACE;
var CODE_SPACE = types.CODE_SPACE;
var MAP_SPACE = types.MAP_SPACE;
var CELL_SPACE = types.CELL_SPACE;
var PROPERTY_CELL_SPACE = types.PROPERTY_CELL_SPACE;
var LARGE_OBJECT_SPACE = types.LARGE_OBJECT_SPACE;
var ALL_SPACES = types.ALL_SPACES;
var TOTAL_TIME = types.TOTAL_TIME;
var EXTERNAL_MEMORY = types.EXTERNAL_MEMORY;
var USED = types.USED;
var AVAILABLE = types.AVAILABLE;
var COMMITED = types.COMMITED;
var PROMOTED = types.PROMOTED;
var PROMOTION = types.PROMOTION;
var START = types.START;

// TODO: DFAs and `startsWith` would be better
// Most regex start with ^[\t ]* and ends with \b
// (unless we are confident about the context) anyway
var dict = (_dict = {}, _defineProperty(_dict, MS, 'ms'), _defineProperty(_dict, KB, 'KB'), _defineProperty(_dict, MB, 'MB'), _defineProperty(_dict, ARROW, '->'), _defineProperty(_dict, SCAVENGE, 'Scavenge'), _defineProperty(_dict, MARK_SWEEP, 'Mark-sweep'), _defineProperty(_dict, MEMORY_ALLOCATOR, 'Memory allocator'), _defineProperty(_dict, NEW_SPACE, 'New space'), _defineProperty(_dict, OLD_POINTERS, 'Old pointers'), _defineProperty(_dict, OLD_DATA_SPACE, 'Old data space'), _defineProperty(_dict, CODE_SPACE, 'Code space'), _defineProperty(_dict, MAP_SPACE, 'Map space'), _defineProperty(_dict, CELL_SPACE, 'Cell space'), _defineProperty(_dict, PROPERTY_CELL_SPACE, 'PropertyCell space'), _defineProperty(_dict, LARGE_OBJECT_SPACE, 'Large object space'), _defineProperty(_dict, ALL_SPACES, 'All spaces'), _defineProperty(_dict, OLD_SPACE, 'Old space'), _defineProperty(_dict, EXTERNAL_MEMORY, 'External memory reported'), _defineProperty(_dict, TOTAL_TIME, 'Total time spent in GC'), _defineProperty(_dict, USED, 'used'), _defineProperty(_dict, AVAILABLE, 'available'), _defineProperty(_dict, COMMITED, 'committed'), _defineProperty(_dict, PROMOTED, 'promoted'), _defineProperty(_dict, START, 'start'), _defineProperty(_dict, PROMOTION, 'promotion'), _dict);

var LexerMark = function LexerMark(rowIndex, colIndex) {
  _classCallCheck(this, LexerMark);

  this.rowIndex = rowIndex;
  this.colIndex = colIndex;
};

/* We don't have a lookahead because the grammar is ambiguous, or,
 * in technical jargons, is neither regular nor LL(1)/LR(1)
 * e.g.:
 * a) A word could very well be a keyword or the start of a sentence
 * b) A literal such as '/' could have no semantic meaning
 *  (just part of a phrase) or be an important separator
 * c) Whitespaces might count in some occasions(see above)
 * If we guess it wrong, it could be very tedious to reassemble a
 * phrase/sentence from the token we've parsed
 * The grammar is also subject to change so better make it
 * more flexible and context sensitive
 */


var Lexer = function () {
  function Lexer(lines) {
    _classCallCheck(this, Lexer);

    this.lines = lines;
    // the rest of the line we need to consume
    // we slice the lines because we use those quick an dirty regex
    // and need that ^
    // TODO: All the slicing and indexing can not be efficient,
    //       altough these strings should be flat from the start.
    //       Maybe we should use typed arrays instead?
    this.line = this.lines[0];
    this.rowIndex = 0; // index of the current line
    this.colIndex = 0; // this index into the current line
  }

  _createClass(Lexer, [{
    key: 'markPosition',
    value: function markPosition() {
      return new LexerMark(this.rowIndex, this.colIndex);
    }

    // TODO: panic mode when we have streaming support

  }, {
    key: 'restorePosition',
    value: function restorePosition(mark) {
      this.rowIndex = mark.rowIndex;
      this.colIndex = mark.colIndex;
      this.line = this.lines[this.rowIndex].slice(this.colIndex);
    }
  }, {
    key: 'isEmptyLine',
    value: function isEmptyLine() {
      var index = 0;
      while (index < this.line.length && (this.line[index] === '\t' || this.line[index] === ' ')) {
        index++;
      }
      return index === this.line.length;
    }
  }, {
    key: 'isEOL',
    value: function isEOL() {
      return this.colIndex === this.lines[this.rowIndex].length;
    }
  }, {
    key: 'isLastLine',
    value: function isLastLine() {
      return this.rowIndex + 1 === this.lines.length;
    }
  }, {
    key: 'skipLine',
    value: function skipLine() {
      this.rowIndex += 1;
      this.colIndex = 0;
      this.line = this.lines[this.rowIndex];
    }

    // [12345]

  }, {
    key: 'scanPIDSource',
    value: function scanPIDSource(source) {
      var PID = new Sym();
      if (this.scanWithRegex(PID, /^[\t ]*\[(\d{1,5})\]/, INTEGER)) {
        source.pid = PID.data;
        return true;
      }
      return false;
    }

    // [12345:0x123a14d]

  }, {
    key: 'scanFullSource',
    value: function scanFullSource(source) {
      var PID = new Sym(),
          isolate = new Sym();
      var colIndex = this.colIndex;
      if (this.scanWithRegex(PID, /^[\t ]*\[(\d{1,5})\:/, INTEGER)) {
        source.pid = PID.data;
        if (this.scanHex(isolate)) {
          source.isolate = isolate.data;
          return true;
        }
      }
      this.colIndex = colIndex;
      return false;
    }

    // [I:0x1234a14d]

  }, {
    key: 'scanIsolateMark',
    value: function scanIsolateMark(source) {
      var isolate = new Sym();
      if (this.scanWithRegex(isolate, /^[\t ]*\[I\:(0x[0-9a-zA-Z]+)\]/, STRING)) {
        source.isolate = isolate.data;
        return true;
      }
      return false;
    }

    // 10495 ms

  }, {
    key: 'scanUpTime',
    value: function scanUpTime(uptime) {
      return this.scanWithRegex(uptime, /^[\t ]*(\d+) ms/, INTEGER);
    }

    // evacuate.update_pointers

  }, {
    key: 'scanNVPName',
    value: function scanNVPName(name) {
      if (this.scanWithRegex(name, /^[\t ]*([0-9a-z\.\_]+)=/, STRING)) {
        this.advanceCol(-1); // =
        return true;
      };
      return false;
    }
  }, {
    key: 'scanUntil',
    value: function scanUntil(str, sym) {
      var index = this.line.indexOf(str);
      if (index === -1) {
        return false;
      }
      sym.type = STRING;
      sym.data = this.line.slice(0, index);
      this.advanceCol(index);
      return true;
    }
  }, {
    key: 'advanceCol',
    value: function advanceCol(count) {
      this.colIndex += count;
      this.line = this.lines[this.rowIndex].slice(this.colIndex);
    }
  }, {
    key: 'scanWithRegex',
    value: function scanWithRegex(sym, regex, type) {
      if (this.isEOL()) {
        return false;
      }
      var match = this.line.match(regex);
      if (!match) {
        return false;
      }
      var data = match[1];
      if (sym) {
        sym.type = type;
        if (type === NUMBER || type === DECIMAL || type === INTEGER) {
          sym.data = Number(data);
        } else {
          sym.data = data;
        }
      }
      this.advanceCol(match[0].length);
      return true;
    }
  }, {
    key: 'scanKeyWord',
    value: function scanKeyWord(type, sym) {
      var str = dict[type];
      var length = this.startsWithIgnoreWS(str);
      if (length) {
        if (sym) {
          sym.type = type;
          sym.data = str;
        }
        this.advanceCol(length);
        return true;
      }
      return false;
    }
  }, {
    key: 'scanLiteralIgnoreWS',
    value: function scanLiteralIgnoreWS(str, result) {
      var length = this.startsWithIgnoreWS(str);
      if (length) {
        if (result) {
          result.type = LITERAL;
          result.data = str;
        }
        this.advanceCol(length);
        return true;
      }
      return false;
    }
  }, {
    key: 'startsWithIgnoreWS',
    value: function startsWithIgnoreWS(str) {
      var skip = 0;
      var index = 0;

      while (this.line[skip] === ' ' || this.line[skip] === '\t') {
        skip++;
      }
      while (skip + index < this.line.length && this.line[skip + index] === str[index]) {
        index++;
      }

      return index === str.length ? skip + index : 0;
    }
  }, {
    key: 'scanHex',
    value: function scanHex(result) {
      return this.scanWithRegex(result, /^(0x[0-9a-zA-Z]+)\]/, HEX);
    }
  }, {
    key: 'scanDecimal',
    value: function scanDecimal(result) {
      return this.scanWithRegex(result, /^[ \t]*([-]?\d+\.\d+)/, DECIMAL);
    }
  }, {
    key: 'scanInteger',
    value: function scanInteger(result) {
      return this.scanWithRegex(result, /^[ \t]*([-]?\d+)/, INTEGER);
    }
  }, {
    key: 'scanNumber',
    value: function scanNumber(result) {
      return this.scanDecimal(result) || this.scanInteger(result);
    }
  }]);

  return Lexer;
}();

module.exports = Lexer;

},{"./sym":4,"./types":5}],3:[function(require,module,exports){
'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _keys;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Sym = require('./sym');
var Lexer = require('./lexer');
var types = require('./types');

var MS = types.MS;
var MB = types.MB;
var KB = types.KB;
var ARROW = types.ARROW;
var SCAVENGE = types.SCAVENGE;
var MARK_SWEEP = types.MARK_SWEEP;
var MEMORY_ALLOCATOR = types.MEMORY_ALLOCATOR;
var OLD_SPACE = types.OLD_SPACE;
var NEW_SPACE = types.NEW_SPACE;
var OLD_POINTERS = types.OLD_POINTERS;
var OLD_DATA_SPACE = types.OLD_DATA_SPACE;
var CODE_SPACE = types.CODE_SPACE;
var MAP_SPACE = types.MAP_SPACE;
var CELL_SPACE = types.CELL_SPACE;
var PROPERTY_CELL_SPACE = types.PROPERTY_CELL_SPACE;
var LARGE_OBJECT_SPACE = types.LARGE_OBJECT_SPACE;
var ALL_SPACES = types.ALL_SPACES;
var TOTAL_TIME = types.TOTAL_TIME;
var EXTERNAL_MEMORY = types.EXTERNAL_MEMORY;
var USED = types.USED;
var AVAILABLE = types.AVAILABLE;
var COMMITED = types.COMMITED;
var PROMOTED = types.PROMOTED;
var START = types.START;
var PROMOTION = types.PROMOTION;

// how to stringify those types
var keys = (_keys = {}, _defineProperty(_keys, SCAVENGE, 'scavenge'), _defineProperty(_keys, MARK_SWEEP, 'mark_sweep'), _defineProperty(_keys, MEMORY_ALLOCATOR, 'memory_allocator'), _defineProperty(_keys, NEW_SPACE, 'new_space'), _defineProperty(_keys, OLD_POINTERS, 'old_pointers'), _defineProperty(_keys, OLD_DATA_SPACE, 'old_data_space'), _defineProperty(_keys, CODE_SPACE, 'code_space'), _defineProperty(_keys, MAP_SPACE, 'map_space'), _defineProperty(_keys, CELL_SPACE, 'cell_space'), _defineProperty(_keys, PROPERTY_CELL_SPACE, 'property_cell_space'), _defineProperty(_keys, LARGE_OBJECT_SPACE, 'large_object_space'), _defineProperty(_keys, ALL_SPACES, 'all_spaces'), _defineProperty(_keys, OLD_SPACE, 'old_space'), _defineProperty(_keys, TOTAL_TIME, 'total_time_spent_in_gc'), _defineProperty(_keys, EXTERNAL_MEMORY, 'external_memory_reported'), _defineProperty(_keys, USED, 'used'), _defineProperty(_keys, AVAILABLE, 'available'), _defineProperty(_keys, COMMITED, 'committed'), _defineProperty(_keys, PROMOTED, 'promoted'), _defineProperty(_keys, START, 'start'), _defineProperty(_keys, PROMOTION, 'promotion'), _keys);

/* The grammar is definitely not regular and not LL(1)/LR(1),
 * so we write a recursive-descent parser and use `this.lexer.markPosition()
 * and `this.lexer.restorePosition(mark)` for backtracking
 */
/* We don't use FIRST/FOLLOW sets strictly because we can choose
 * what kinds of logs we want to support,
 * so no need to trade complexity for flexibility
 */
/* Right now we don't build a meaningful AST(parseAll return undefined)
 * but it's planned for better tooling support
 */
/* Note:
 *  a) Trace and NVPTrace don't appear in the same log.
 *    There is an if-else in gc_tracer.cc
 *  b) We assume there won't be any normal stdout output inside
 *    a trace. This is especially important to the multi-line verbose trace.
 */
/*
 * TODO: some 'return false' should throw exceptions instead
 */

var GCLParser = function () {
  function GCLParser() {
    _classCallCheck(this, GCLParser);
  }

  _createClass(GCLParser, [{
    key: 'parseAllToData',
    value: function parseAllToData(text) {
      // TODO: when parseAll returns an AST
      // we need a method to walk that and output data
      this.parseAll(text);
      return this.data;
    }
  }, {
    key: 'parseAll',
    value: function parseAll(text) {
      var lines = text.split('\n').concat(['']);
      this.lexer = new Lexer(lines);
      this.data = [];

      var holder = {};
      // TODO: if there is only one line?
      while (!this.lexer.isLastLine()) {
        if (this._GCLog(holder)) {
          this.data.push(holder.data);
        } else {}
        // this line is not a GC log and is skipped

        // here we are at the start of the next line to parse
        if (!this.lexer.isLastLine() && this.lexer.isEmptyLine()) {
          this.lexer.skipLine(); // this may cosumes the last new line
        }
      }
      if (this.data.length && !this.version) {
        this.version = 'v6.x';
      }

      // TODO: should return an AST(indexes included) for tooling
      return;
    }

    // Source Trace '\n'
    // might not need '\n' to be more fault tolerant
    // and we can't assume the log ends with a new line

  }, {
    key: '_GCLog',
    value: function _GCLog(holder) {
      var source = {},
          trace = {};
      if (this._Source(source, trace) && this._Trace(source, trace)) {
        holder.data = Object.assign(source, trace);
        if (!this.lexer.isLastLine()) {
          this.lexer.skipLine();
        }
        return true;
      }
      // unknown trace
      if (!this.lexer.isLastLine()) {
        this.lexer.skipLine();
      }
      return false;
    }

    // Here the matching is delegated to the lexer using regex
    // since the format is easy to express in regex and
    // it's much cleaner that way
    // PIDSource | FullSource [IsolateMark]

  }, {
    key: '_Source',
    value: function _Source(source, trace) {
      var pid = new Sym();
      var isolate = new Sym();
      var mark = this.lexer.markPosition();

      // '[' PID ']'
      if (this.lexer.scanPIDSource(source)) {
        source.version = 'v0.12.x';
        return true;
      }

      // '[' PID ':' Isolate ']'
      if (this.lexer.scanFullSource(source)) {
        // '[I:' Isolate ']'
        if (this.lexer.scanIsolateMark(source)) {
          trace.type = 'nvp';
          this.version = 'v4.x';
        }
        return true;
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // Note when this returns true
    // we are still at the end of the last line

  }, {
    key: '_Trace',
    value: function _Trace(source, trace) {
      var mark = this.lexer.markPosition();
      var uptime = new Sym();
      // UpTime ':'  GCTrace
      // UpTime ':'  NVPTrace
      // we use regex to scan uptime because it's easier
      if (this.lexer.scanUpTime(uptime) && this._Literal(':')) {
        trace.time_since_init = uptime.data;
        if (this._NVPTrace(source, trace)) {
          return true;
        }
        if (this._GCTrace(source, trace)) {
          return true;
        }
        this.lexer.restorePosition(mark);
        return false;
      }

      // VerboseTrace
      if (this._VerboseTrace(source, trace)) {
        return true;
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // NVP | NVP NVPTrace
    // we don't do recursion here in case of overflow

  }, {
    key: '_NVPTrace',
    value: function _NVPTrace(source, trace) {
      var mark = this.lexer.markPosition();
      var nvp = {};

      // at least one nvp
      if (!this._NVP(nvp)) {
        this.lexer.restorePosition(mark);
        return false;
      }
      while (!this.lexer.isEOL() && this._NVP(nvp)) {
        ;
      }
      trace.data = nvp;
      trace.type = 'nvp';
      return true;
    }

    // NVP: NVPName '=' NVPValue

  }, {
    key: '_NVP',
    value: function _NVP(nvp) {
      var mark = this.lexer.markPosition();
      var name = new Sym(),
          value = new Sym();
      if (this._NVPName(name) && this._Literal('=') && this._NVPValue(value)) {
        nvp[name.data] = value.data;
        return true;
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // Number | Number '%' | 'ms' | 's'
    // too complicated for regex

  }, {
    key: '_NVPValue',
    value: function _NVPValue(value) {
      var mark = this.lexer.markPosition();
      if (this._Number(value)) {
        this._Literal('%');
        return true;
      }
      if (this._Literal('ms', value) || this._Literal('s', value)) {
        return true;
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // easier to express in regex

  }, {
    key: '_NVPName',
    value: function _NVPName(name) {
      return this.lexer.scanNVPName(name);
    }

    // Collector MemoryChange ',' TimeSpent Explanation
    // too complicated for regex

  }, {
    key: '_GCTrace',
    value: function _GCTrace(source, trace) {
      var mark = this.lexer.markPosition();
      var collector = {};
      var change = {};
      var pause = {};
      var explanation = {};
      var data = {};
      if (this._Collector(collector) && this._MemoryChange(change) && this._Literal(',') && this._TimeSpent(pause) && this._Explanation(explanation)) {
        Object.assign(data, collector, change, pause, explanation);
        if (Object.keys(data).length) {
          trace.data = data;
          trace.type = 'trace';
        }
        return true;
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // 'Scavenge' | 'Mark-sweep'

  }, {
    key: '_Collector',
    value: function _Collector(collector) {
      var keyword = new Sym();
      if (this._KeyWord(SCAVENGE, keyword) || this._KeyWord(MARK_SWEEP, keyword)) {
        collector.collector = keys[keyword.type];
        return true;
      }
      return false;
    }

    // ObjectSize '(' MemorySize ')' Arrow ObjectSize '(' MemorySize ')' MB
    // too complicated for regex since we have decimal/integer numbers
    // and can't match things like '43.'

  }, {
    key: '_MemoryChange',
    value: function _MemoryChange(change) {
      var mark = this.lexer.markPosition();
      var startObjectSize = new Sym(),
          endObjectSize = new Sym(),
          startMemorySize = new Sym(),
          endMemorySize = new Sym();
      if (this._Number(startObjectSize) && this._Literal('(') && this._Number(startMemorySize) && this._Literal(')') && this._KeyWord(ARROW) && this._Number(endObjectSize) && this._Literal('(') && this._Number(endMemorySize) && this._Literal(')') && this._KeyWord(MB)) {
        change.start_object_size = startObjectSize.data;
        change.end_object_size = endObjectSize.data;
        change.start_memory_size = startMemorySize.data;
        change.end_memory_size = endMemorySize.data;
        return true;
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    // PauseTime MS | PauseTime '/' ExternalTime MS
    // too complicated for regex since we have decimal/integer numbers

  }, {
    key: '_TimeSpent',
    value: function _TimeSpent(time) {
      var mark = this.lexer.markPosition();
      var pause = new Sym(),
          external = new Sym();
      if (this._Number(pause)) {
        time.pause = pause.data;
        if (this._KeyWord(MS)) {
          return true;
        }
        if (this._Literal('/') && this._Number(external) && this._KeyWord(MS)) {
          time.external_time = external.data;
          return true;
        }
      }

      this.lexer.restorePosition(mark);
      return false;
    }

    // [StepDescription] [GCReason] [CollectorReason]

  }, {
    key: '_Explanation',
    value: function _Explanation(explanation) {
      var step = new Sym(),
          gcReason = new Sym(),
          cReason = new Sym();
      if (this._StepDescription(step)) {
        explanation.step_description = step.data;
      }
      // reason and steps are optional
      if (this._Reason(gcReason)) {
        explanation.gc_reason = gcReason.data;
        if (this._Reason(cReason)) {
          explanation.collector_reason = cReason.data;
        }
      }

      // technically it can be blank..so
      return true;
    }

    // '(' Sentence ')'

  }, {
    key: '_StepDescription',
    value: function _StepDescription(sym) {
      var mark = this.lexer.markPosition();
      if (this._Literal('(') && this.lexer.scanUntil(')', sym) && this._Literal(')')) {
        return true;
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    // '[' Sentence ']'

  }, {
    key: '_Reason',
    value: function _Reason(sym) {
      var mark = this.lexer.markPosition();
      if (this._Literal('[') && this.lexer.scanUntil(']', sym) && this._Literal(']')) {
        return true;
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    // VerboseTraceStart '\n'
    // VerboseTraceHeapList  '\n'
    // VerboseTraceExternal '\n'
    // VerboseTraceEnd

  }, {
    key: '_VerboseTrace',
    value: function _VerboseTrace(source, trace) {
      var mark = this.lexer.markPosition();
      var data = {};
      // this could be implemented as a DFA?
      if (this._VerboseTraceStart(source, data) && !this.lexer.isLastLine()) {
        // only a start, no following lines, fail
        this.lexer.skipLine();
        var _source = {};

        if (!this._VerboseTraceHeapList(_source, data)) {
          this.lexer.restorePosition(mark);
          return false;
        }

        // the Source is cosumed in the loop condition
        if (!this._VerboseTraceExternal(_source, data) || this.lexer.isLastLine()) {
          // no proper ending, fail
          this.lexer.restorePosition(mark);
          return false;
        }
        this.lexer.skipLine();

        if (!this._Source(_source) || !this._VerboseTraceEnd(_source, data)) {
          this.lexer.restorePosition(mark);
          return false;
        }
        if (this._isVerboseComplete(_source, data)) {
          trace.type = 'verbose';
          trace.data = data;
          return true;
        };
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    //   Source VerboseTraceHeap
    // | Source VerboseTraceHeap VerboseTraceHeapList

  }, {
    key: '_VerboseTraceHeapList',
    value: function _VerboseTraceHeapList(source, data) {
      var mark = this.lexer.markPosition();
      // iteration instead of recursion
      // since we know when to stop
      // we can't be too strict about the order of
      // the traces in case of future updates
      // TODO: this should be able to handle streaming
      while (this._Source(source) && this._VerboseTraceHeap(source, data)) {
        // no proper ending, fail
        if (this.lexer.isLastLine()) {
          this.lexer.restorePosition(mark);
          return false;
        }
        this.lexer.skipLine();
      }
      return true;
    }

    // 'Memory allocator' ',' HeapStatsList

  }, {
    key: '_VerboseTraceStart',
    value: function _VerboseTraceStart(source, data) {
      var mark = this.lexer.markPosition();
      if (this._KeyWord(MEMORY_ALLOCATOR)) {
        var stats = {};
        if (this._HeapStatsList(stats)) {
          data.memory_allocator = stats;
          return true;
        }
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    // HeapSection HeapStatsList

  }, {
    key: '_VerboseTraceHeap',
    value: function _VerboseTraceHeap(source, trace) {
      var mark = this.lexer.markPosition();
      var keyword = new Sym();
      if (this._HeapSection(keyword)) {
        var stats = {};
        if (this._HeapStatsList(stats)) {
          trace[keys[keyword.type]] = stats;
          return true;
        }
      }
      this.lexer.restorePosition(mark);
      return false;
    }
  }, {
    key: '_HeapSection',
    value: function _HeapSection(keyword) {
      return this._KeyWord(NEW_SPACE, keyword) // v4.x/6.x
      || this._KeyWord(OLD_SPACE, keyword) || this._KeyWord(CODE_SPACE, keyword) || this._KeyWord(MAP_SPACE, keyword) || this._KeyWord(LARGE_OBJECT_SPACE, keyword) || this._KeyWord(ALL_SPACES, keyword)
      // v0.12.x
      || this._KeyWord(OLD_POINTERS, keyword) || this._KeyWord(OLD_DATA_SPACE, keyword) || this._KeyWord(CELL_SPACE, keyword) || this._KeyWord(PROPERTY_CELL_SPACE, keyword);
    }

    // 'External memory reported' ':' Number KB

  }, {
    key: '_VerboseTraceExternal',
    value: function _VerboseTraceExternal(source, trace) {
      var mark = this.lexer.markPosition();
      if (this._KeyWord(EXTERNAL_MEMORY)) {
        var value = {};
        if (this._Literal(':') && this._Number(value) && this._KeyWord(KB)) {
          trace.external_memory_reported = value.data;
          return true;
        }
      }
      this.lexer.restorePosition(mark);
      return false;
    }

    // 'Total time spent in GC' ':' Number MS

  }, {
    key: '_VerboseTraceEnd',
    value: function _VerboseTraceEnd(source, trace) {
      var mark = this.lexer.markPosition();
      if (this._KeyWord(TOTAL_TIME)) {
        var value = {};
        if (this._Literal(':') && this._Number(value) && this._KeyWord(MS)) {
          trace.total_time_spent_in_gc = value.data;
          return true;
        }
      }
      this.lexer.restorePosition(mark);
      return false;
    }
  }, {
    key: '_isVerboseComplete',
    value: function _isVerboseComplete(source, trace) {
      return _typeof(trace.memory_allocator) === 'object' && typeof trace.total_time_spent_in_gc === 'number' && typeof trace.external_memory_reported === 'number';
    }

    // ',' StatName ':' StatValue KB

  }, {
    key: '_HeapStatsList',
    value: function _HeapStatsList(stats) {
      var mark = this.lexer.markPosition();
      var name = new Sym(),
          value = new Sym();
      while (!this.lexer.isEOL() && this._Literal(',')) {
        if (this._StatName(name) && this._Literal(':') && this._Number(value) && this._KeyWord(KB)) {
          stats[keys[name.type]] = value.data;
        } else {
          break; // we allow partial stats here
        }
      }
      if (Object.keys(stats).length) {
        return true;
      }
      this.lexer.restorePosition(mark);
      return false;
    }
  }, {
    key: '_StatName',
    value: function _StatName(sym) {
      return this._KeyWord(USED, sym) || this._KeyWord(AVAILABLE, sym) || this._KeyWord(COMMITED, sym) || this._KeyWord(PROMOTED, sym) || this._KeyWord(START, sym) || this._KeyWord(PROMOTION, sym);
    }
  }, {
    key: '_Number',
    value: function _Number(sym) {
      return this.lexer.scanNumber(sym);
    }
  }, {
    key: '_Literal',
    value: function _Literal(str, sym) {
      return this.lexer.scanLiteralIgnoreWS(str, sym);
    }
  }, {
    key: '_KeyWord',
    value: function _KeyWord(type, sym) {
      return this.lexer.scanKeyWord(type, sym);
    }
  }]);

  return GCLParser;
}();

module.exports = GCLParser;

},{"./lexer":2,"./sym":4,"./types":5}],4:[function(require,module,exports){
'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sym = function Sym(type, data) {
  _classCallCheck(this, Sym);

  this.type = type;
  this.data = data;
};

module.exports = Sym;

},{}],5:[function(require,module,exports){
'use strict';

module.exports = {
  HEX: 'HEX',
  NUMBER: 'NUMBER',
  DECIMAL: 'DECIMAL',
  INTEGER: 'INTEGER',
  STRING: 'STRING',
  LITERAL: 'LITERAL',
  MS: 'MS',
  MB: 'MB',
  KB: 'KB',
  ARROW: 'ARROW',
  ISOLATE: 'ISOLATE',
  SCAVENGE: 'scavenge',
  MARK_SWEEP: 'mark_sweep',
  MEMORY_ALLOCATOR: 'memory_allocator',
  NEW_SPACE: 'new_space',
  OLD_POINTERS: 'old_pointers',
  OLD_DATA_SPACE: 'old_data_space',
  CODE_SPACE: 'code_space',
  MAP_SPACE: 'map_space',
  CELL_SPACE: 'cell_space',
  PROPERTY_CELL_SPACE: 'property_cell_space',
  LARGE_OBJECT_SPACE: 'large_object_space',
  ALL_SPACES: 'all_spaces',
  OLD_SPACE: 'old_space',
  TOTAL_TIME: 'total_time_spent_in_gc',
  EXTERNAL_MEMORY: 'external_memory_reported',
  USED: 'used',
  AVAILABLE: 'available',
  COMMITED: 'committed',
  PROMOTED: 'promoted',
  START: 'start',
  PROMOTION: 'promotion'
};

},{}]},{},[1])(1)
});